clean up and homogenize pgsql and mysql vserver checks
[matthijs/upstream/backupninja.git] / handlers / pgsql
index 8d8f0c78eecf035d21ec324d182708241a31489a..2b6f25a421d67892c1c7218c68e66472ae7f3ddd 100644 (file)
@@ -1,3 +1,4 @@
+# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
 #
 # PostgreSQL handler script for backupninja
 #
@@ -9,35 +10,60 @@ getconf vsname
 
 localhost=`hostname`
 
-# If vservers are configured, decide if the handler should
-# use them or if it should just operate on the host
-
-if [ "$vservers" == "yes" ]
-    then
-    if [ ! -z $vsname ]
-       then            
-       info "Using vserver '$vsname'"
-       usevserver=1
-    else
-       info "No vserver name specified, actions will be performed on the host"
-    fi
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
+local usevserver=no
+local vroot
+if [ $vservers_are_available = yes ]; then
+   if [ -z "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
+      usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
+   fi
 fi
 
-# Check to make sure that the specified vserver exists
-if [ $usevserver ]
-    then
-    vroot="$VROOTDIR/$vsname"
-    [ -d $vroot ] || fatal "vserver '$vsname' does not exist at '$vroot'"
+# Make sure that the system to backup has the needed executables
+if [ $usevserver = yes ]; then
+   debug "Examining vserver '$vsname'."
+   if [ "$databases" == "all" ]; then
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
+   else
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP in vserver $vsname."
+   fi
+else
+   if [ "$databases" == "all" ]; then
+      [ -x "`which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL."
+   else
+      [ -x "`which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP."
+   fi
 fi
 
 # create backup dir, the vroot variable will be empty if no vsname was specified
 # and will proceed to operate on the host
-[ -d $vroot$backupdir ] || mkdir -p $vroot$backupdir
+[ -d $vroot$backupdir ] || (debug "mkdir -p $vroot$backupdir"; mkdir -p $vroot$backupdir)
 [ -d $vroot$backupdir ] || fatal "Backup directory '$vroot$backupdir'"
 
 # give backup dir the good uid and permissions
-# (in respect to the vserver, if $usevserver)
-pguid=`grep '^postgres:' $vroot/etc/passwd | awk -F: '{print $3}'`
+# (in respect to the vserver, if $usevserver = yes)
+pguid=`getent passwd postgres | awk -F: '{print $3}'`
+[ -n "$pguid" ] || \
+    fatal "No user called postgres`[ $usevserver = no ] || echo \" on vserver $vsname\"`."
 debug "chown $pguid $vroot$backupdir"
 chown $pguid $vroot$backupdir
 debug "chmod 700 $vroot$backupdir"
@@ -45,15 +71,15 @@ chmod 700 $vroot$backupdir
 
 # if $databases = all, use pg_dumpall
 if [ "$databases" == "all" ]; then
-    if [ $usevserver ]; then
-       execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMPALL > $vroot$backupdir/${vsname}.sql"
+    if [ $usevserver = yes ]; then
+       execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMPALL > $backupdir/${vsname}.sql"
     else
        execstr="su - postgres -c $PGSQLDUMPALL > $backupdir/${localhost}-all.sql"
     fi
     debug "$execstr"
     if [ ! $test ]; then
-       output=`$execstr 2>&1`
-       code=$?
+       output=`$execstr 2>&1`
+       code=$?
        if [ "$code" == "0" ]; then
            debug $output
            info "Successfully finished dump of pgsql cluster"
@@ -66,9 +92,9 @@ if [ "$databases" == "all" ]; then
 # else use pg_dump on each specified database
 else
     for db in $databases; do
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
            then
-           execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMP $db > $vroot$backupdir/${db}.sql"
+           execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMP $db > $backupdir/${db}.sql"
        else
            execstr="su - postgres -c $PGSQLDUMP $db > $backupdir/${db}.sql"
        fi